/***********************************************************
*                       pC/OS 1.88c                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
* Permission to use, copy, modify, and distribute this     *
* software in source and binary forms and its              *
* documentation for any purpose and without fee is hereby  *
* granted, provided that the above authors notice appear   *
* in all copies and that both that authors notice and this *
* permission notice appear in supporting documentation.    *
*                                                          *
* THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND   *
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT    *
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY    *
* AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     *
* IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,  *
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR             *
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,    *
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     *
* USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER *
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN        *
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE   *
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY *
* OF SUCH DAMAGE.                                          *
************************************************************
*                    pC_OS_internal.h                      *
*                  INTERNAL DECLARATIONS                   *
***********************************************************/
#ifndef _pC_OS_INT_
 #define _pC_OS_INT_

/*
************************************************************
*                  DYN-PIPE DATA STRUCTURE                 *
************************************************************
*/
OS_PACKED typedef struct os_dp {
    struct os_dp OS_HUGE *OSDPNext;
    U16          OSDPLenght;
    U08          OSDPData[];
} OS_PACKED_ATTR OS_DP;
/*
************************************************************
*             pC/OS INTERNAL GLOBAL VARIABLES              *
************************************************************
*/
OS_EXT BOOLEAN     OSRunning;
OS_EXT OS_TCB     *OSTCBCur;
OS_EXT OS_TCB     *OSTCBHighRdy;
OS_EXT U08         OSRdyGrp;
OS_EXT U08         OSRdyTbl[];
OS_EXT OS_TCB     *OSTCBPrioTbl[];
OS_EXT OS_TCB      OSTCBTbl[];
OS_EXT OS_TCB     *OSTCBList;
OS_EXT U16         OSLockNesting;
OS_EXT U08         OSIntNesting;
OS_EXT OS_TCB     *OSTCBFreeList;
OS_EXT U32         OSTime;
OS_EXT U16         OSIdleCnt;
OS_EXT U08         OSHWriteIndex;
OS_EXT U08         OSHEntryCount;
OS_EXT U08         OSHReadIndex;
/*
************************************************************
*              pC/OS USER CALL-BACK FUNCTIONS              *
************************************************************
*/
void OSStkEndError(void);
void OSMemChkError(void);
void OSMutexReInitResource(OS_MUX *mutex, U08 id);
/*
************************************************************
*                pC/OS INTERNAL PROTOTYPES                 *
************************************************************
*/
void OSSemDestroyTask(OS_SEM *psem, U08 prio);
void OSMutexDestroyTask(OS_MUX *pmux, U08 prio);
void OSMboxDestroyTask(OS_MBOX *pmbox, U08 prio);
void OSQueueDestroyTask(OS_Q *pq, U08 prio);
void OSPipeDestroyTask(OS_P *pp, U08 prio);
void OSEvgDestroyTask(OS_EVG *pevg, U08 prio);
U08  OSMutexFreeTask(OS_MUX *pmux, U08 prio);
U08  OSMemCleanUp(U08 userId);

/************************** END ***************************/
#endif

