/***************************************************************
 *                       pC/OS 1.87b                           *
 *                      a FREE - RTOS                          *
 *                                                             *
 *                 based on the C/OS 1.00                     *
 *                   by  Jean J. Labrosse                      *
 *                                                             *
 *    changed by Frank Goetze  -  www.embedded-os.de           *
 ***************************************************************
 *                      OS_RX62N_a.s                           *
 *               Renesas RX62N Specific Code                   *
 *                       using IAR                             *
 ***************************************************************/

    extern  _OSTCBCur
    extern  _OSTCBHighRdy
    extern  _OSTickISR
    extern  _OSIntExit
    extern  _OSIntNesting

    module  PCOS
    section .text:CODE:NOROOT
    code

/***************************************************************
 *                         marcos
 **************************************************************/

save_context macro
        push.l  r15
        mvfc    usp, r15
        sub     #12, r15
        mvtc    r15, usp
        mov.l   [r0],[r15]
        mov.l   4[r0], 4[r15]
        mov.l   8[r0], 8[r15]
        add     #12, r0
        setpsw  u
        pushm   r1-r14
        mvfachi r15
        push.l  r15
        mvfacmi r15
        shll    #16, r15
        push.l  r15
    endm

restore_context macro
        pop     r15
        mvtaclo r15
        pop     r15
        mvtachi r15
        popm    r1-r15
    endm
    
/***************************************************************
                     START MULTITASKING
                  void OSStartHighRdy(void)
 ***************************************************************/
    public _OSStartHighRdy
_OSStartHighRdy:
        setpsw  u

        mov.l   #_OSTCBCur, r5
        mov.l   #_OSTCBHighRdy, r4
        mov.l   [r4], r3
        mov.l   r3, [r5]
        mov.l   [r3], r0

        restore_context
        rte
        nop
        nop

/***************************************************************
           PERFORM A CONTEXT SWITCH (From task level)
                      void OSCtxSw(void)
 ***************************************************************
                       not needed here
 ***************************************************************/

/***************************************************************
           PERFORM A CONTEXT SWITCH (From an ISR)
                    void OSIntCtxSw(void)
 ***************************************************************
                       not needed here
 ***************************************************************/
    public _OSIntCtxSw
_OSIntCtxSw:
        mov.l   #_OSTCBCur, r5
        mov.l   #_OSTCBHighRdy, r4
        mov.l   [r4], r3
        mov.l   r3, [r5]
        mov.l   [r3], r0

        restore_context
        rte
        nop
        nop

/***************************************************************
                    HANDLE CONTEXT-SWITCH
                   void OSPendSV_ISR(void)
 ***************************************************************/
    public _OSPendSV_ISR
    public ___interrupt_27     // VECT_ICU_SWINT
_OSPendSV_ISR:
___interrupt_27:
        setpsw  i
        save_context
        
        mov.l   #_OSTCBCur, r5
        mov.l   [r5], r2
        mov.l   r0, [r2]
        mov.l   #_OSTCBHighRdy, r4
        mov.l   [r4], r3
        mov.l   r3, [r5]
        mov.l   [r3], r0

        restore_context
        rte
        nop
        nop

/***************************************************************
                       HANDLE TICK ISR
                    void OSTick_ISR(void)
 ***************************************************************/
    public _OSTick_ISR
    public ___interrupt_28     // VECT_CMT0_CMI0
_OSTick_ISR:
___interrupt_28:
        setpsw  i
        save_context

        mov.l   #_OSIntNesting, r5
        mov.l   [r5], r2
        cmp     #0, r2
        bne     OSTick_nosave
        nop
        mov.l   #_OSTCBCur, r4
        mov.l   [r4], r3
        mov.l   r0, [r3]
OSTick_nosave:
        add     #1, r2
        mov.l   r2, [r5]

        bsr.a   _OSTickISR
        nop
        
        bsr.a   _OSIntExit
        nop
        restore_context
        rte
        nop
        nop

/***************************************************************
                    SPECIAL INT-SAVE CALLS
                  OS_STK_TYPE OSEnterCrit(void)
                  void OSExitCrit(OS_STK_TYPE)
 ***************************************************************
                       not needed here
 ***************************************************************/


/***************************************************************/


